<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): /home/mohamed/code/tigl/src/app/tiglAppPageRank.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_ff4b04dd53616468f2d812c0c78deef9.html">app</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglAppPageRank.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglAppPageRank_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLAPPPAGERANK_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLAPPPAGERANK_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"> * GLOBAL DEFINITIONS</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment"> * PageRankVertex class</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>&gt;</div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classVertexPageRank.html">   81</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexPageRank.html">PageRankVertex</a>: <span class="keyword">public</span> <a class="code" href="classVertex.html">Vertex</a>&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;,</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;      uint_fast32_t, uint_fast32_t, DblMessage&gt; {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>,</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;         uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertex.html">Vertex&lt;DataType, double, TIGLContainersEdgeBase&lt;uint_fast32_t&gt;</a>,</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;         uint_fast32_t, uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;::OUT_EDGE_ITERATOR OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">    * Attributes</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">   96</a></span>&#160;   <span class="keyword">static</span> uint_fast32_t <a class="code" href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">numVertices</a>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">  111</a></span>&#160;   <a class="code" href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">PageRankVertex</a>(uint_fast32_t key) :</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;         <a class="code" href="classVertex.html">Vertex</a>&lt;char, double, <a class="code" href="classEdgeBase.html">TIGLContainersEdgeBase</a>&lt;uint_fast32_t&gt;, uint_fast32_t,</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;               uint_fast32_t, <a class="code" href="classMessage.html">DblMessage</a>&gt;(key, true, false) {</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;   }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ab76e34e34bfdfb12999cce62295fdf8f">  121</a></span>&#160;   <a class="code" href="classVertexPageRank.html#ab76e34e34bfdfb12999cce62295fdf8f">~PageRankVertex</a>() {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;   }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment">    * public Methods</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">  141</a></span>&#160;   uint_fast32_t <a class="code" href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">compute</a>(MESSAGE_BUF_TYPE *pIn,</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;         vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut, uint_fast32_t numMessages) {</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;      <span class="keywordtype">double</span> newRank = 0.0;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; 1)</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;!!! Warning PageRankVertex compute: numMessages(&quot;</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;               &lt;&lt; this-&gt;getId() &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;      <span class="keywordflow">if</span> (numMessages &gt; pIn-&gt;size())</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;         cout</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;               &lt;&lt; <span class="stringliteral">&quot;!!! Warning PageRankVertex compute: numMessages is bigger than buffer size&quot;</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;               &lt;&lt; endl;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;      vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      <span class="keywordflow">for</span> (uint_fast32_t loopCount = 0; loopCount &lt; numMessages; loopCount++)   <span class="comment">//itm != pIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            {</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;         newRank += itm-&gt;getContent();</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;         ++itm;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;      }</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;      newRank = newRank * 0.85 + 0.15 / (double) numVertices;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;      this-&gt;algData = newRank;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;      uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;      <span class="keywordtype">double</span> messageVal = (this-&gt;algData) / (<span class="keywordtype">double</span>) (this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator();</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            ite != this-&gt;getEndOutEdgeIterator(); ++ite) {</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;         uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;         <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;         <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;         pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;         numOutMessages++;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;      }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;      <span class="comment">//this-&gt;flagActive = true;</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;      <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;   }</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALLOCATOR_TYPE&gt;</div>
<div class="line"><a name="l00193"></a><span class="lineno"><a class="line" href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">  193</a></span>&#160;   uint_fast32_t <a class="code" href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">init</a>(uint_fast32_t *pNumVertices,</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;         vector&lt;DblMessage, ALLOCATOR_TYPE&gt; *pOut) {</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;      numVertices = *pNumVertices;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;      this-&gt;algData = 1.0 / numVertices;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;      <span class="keywordtype">double</span> messageVal = (this-&gt;algData) / (<span class="keywordtype">double</span>) (this-&gt;getNumOutEdges());</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;      uint_fast32_t numOutMessages = 0;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;      <span class="keywordflow">for</span> (OUT_EDGE_ITERATOR ite = this-&gt;getBeginOutEdgeIterator();</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            ite != this-&gt;getEndOutEdgeIterator(); ++ite) {</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;         uint_fast32_t dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;         <span class="keywordflow">if</span> (dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;            <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;         <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;         pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;         numOutMessages++;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;      }</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;      this-&gt;flagActive = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;      <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   }</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;};</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> DataType&gt;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;uint_fast32_t <a class="code" href="classVertexPageRank.html">PageRankVertex&lt;DataType&gt;::numVertices</a>;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="comment"> * tiglCombinerPageRank class</span></div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00232"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html">  232</a></span>&#160;<span class="keyword">class </span><a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>: <span class="keyword">public</span> <a class="code" href="classtiglCombiner.html">tiglCombiner</a>&lt;DblMessage&gt; {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;   <a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>() {</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;   }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;   ~<a class="code" href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a>() {</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;   }</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;   <span class="comment">/*******************************************************************************</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">    * class methods</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00257"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">  257</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">combineMessages</a>(MESSAGE_ITERATOR itIn,</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;         uint_fast32_t numMessages, MESSAGE_ITERATOR itOut) {</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;      <span class="keywordflow">return</span> this-&gt;sumCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;   }</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;   <span class="comment">/******************************************************************************/</span></div>
<div class="line"><a name="l00270"></a><span class="lineno"><a class="line" href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">  270</a></span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">combineMessages</a>(<a class="code" href="classMessage.html">DblMessage</a> &amp; newMessage,</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;         MESSAGE_ITERATOR itOut) {</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;      <span class="keywordflow">return</span> this-&gt;sumCombineMessages(newMessage, itOut);</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;   }</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;};</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLAPPPAGERANK_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classtiglCombiner_html"><div class="ttname"><a href="classtiglCombiner.html">tiglCombiner</a></div><div class="ttdoc">pure combiner class for the TIGL engine </div><div class="ttdef"><b>Definition:</b> tiglAPICombiner.hpp:68</div></div>
<div class="ttc" id="classVertexPageRank_html_ab76e34e34bfdfb12999cce62295fdf8f"><div class="ttname"><a href="classVertexPageRank.html#ab76e34e34bfdfb12999cce62295fdf8f">PageRankVertex::~PageRankVertex</a></div><div class="ttdeci">~PageRankVertex()</div><div class="ttdoc">destructor </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:121</div></div>
<div class="ttc" id="classtiglCombinerPageRank_html"><div class="ttname"><a href="classtiglCombinerPageRank.html">tiglCombinerPageRank</a></div><div class="ttdoc">Combiner class for the Page Rank algorithm. </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:232</div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdoc">core data message class definition </div><div class="ttdef"><b>Definition:</b> tiglAPIMessage.hpp:69</div></div>
<div class="ttc" id="classVertexPageRank_html_ac8e29e2a338d708f74f1e0ab7f0e4955"><div class="ttname"><a href="classVertexPageRank.html#ac8e29e2a338d708f74f1e0ab7f0e4955">PageRankVertex::compute</a></div><div class="ttdeci">uint_fast32_t compute(MESSAGE_BUF_TYPE *pIn, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut, uint_fast32_t numMessages)</div><div class="ttdoc">customized compute function </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:141</div></div>
<div class="ttc" id="classVertexPageRank_html"><div class="ttname"><a href="classVertexPageRank.html">PageRankVertex</a></div><div class="ttdoc">Customized class for the Page Rank algorithm. </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:81</div></div>
<div class="ttc" id="classtiglCombinerPageRank_html_a7aa6ec254b762243317a39dd8865dd46"><div class="ttname"><a href="classtiglCombinerPageRank.html#a7aa6ec254b762243317a39dd8865dd46">tiglCombinerPageRank::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function the combines a set of messages that calls the generic sum combine ...</div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:257</div></div>
<div class="ttc" id="classVertexPageRank_html_a982b395425a77266ee20f9b1ec85735b"><div class="ttname"><a href="classVertexPageRank.html#a982b395425a77266ee20f9b1ec85735b">PageRankVertex::numVertices</a></div><div class="ttdeci">static uint_fast32_t numVertices</div><div class="ttdoc">numVertices: a static member that holds the total number of vertices </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:96</div></div>
<div class="ttc" id="classEdgeBase_html"><div class="ttname"><a href="classEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">core edge class </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:66</div></div>
<div class="ttc" id="tiglMessage_8hpp_html"><div class="ttname"><a href="tiglMessage_8hpp.html">tiglAPIMessage.hpp</a></div></div>
<div class="ttc" id="tiglCombiner_8hpp_html"><div class="ttname"><a href="tiglCombiner_8hpp.html">tiglAPICombiner.hpp</a></div></div>
<div class="ttc" id="classtiglCombinerPageRank_html_a3b9fb314bdb02926e40fe61ae69f7ec7"><div class="ttname"><a href="classtiglCombinerPageRank.html#a3b9fb314bdb02926e40fe61ae69f7ec7">tiglCombinerPageRank::combineMessages</a></div><div class="ttdeci">uint_fast32_t combineMessages(DblMessage &amp;newMessage, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">overloaded customized combine function that combines a single message </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:270</div></div>
<div class="ttc" id="tiglVertex_8hpp_html"><div class="ttname"><a href="tiglVertex_8hpp.html">tiglAPIVertex.hpp</a></div></div>
<div class="ttc" id="classVertexPageRank_html_ad059296361152b10c464f3dd94f852d8"><div class="ttname"><a href="classVertexPageRank.html#ad059296361152b10c464f3dd94f852d8">PageRankVertex::PageRankVertex</a></div><div class="ttdeci">PageRankVertex(uint_fast32_t key)</div><div class="ttdoc">constructor enable vertex processing even in the absence of messages </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:111</div></div>
<div class="ttc" id="classVertexPageRank_html_ab0311d771c6c45604d015ee3dbc3f78a"><div class="ttname"><a href="classVertexPageRank.html#ab0311d771c6c45604d015ee3dbc3f78a">PageRankVertex::init</a></div><div class="ttdeci">uint_fast32_t init(uint_fast32_t *pNumVertices, vector&lt; DblMessage, ALLOCATOR_TYPE &gt; *pOut)</div><div class="ttdoc">customized init function </div><div class="ttdef"><b>Definition:</b> tiglAppPageRank.hpp:193</div></div>
<div class="ttc" id="classVertex_html"><div class="ttname"><a href="classVertex.html">Vertex</a></div><div class="ttdoc">core vertex class for the TIGL Engine (with only output edge buffer). </div><div class="ttdef"><b>Definition:</b> tiglAPIVertex.hpp:88</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Feb 25 2015 13:02:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
